<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>問題12-4 - 継続型ランダムウォーク &mdash; 計算機実習2014</title>
    
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="author" title="このドキュメントについて" href="../about.html" />
    <link rel="top" title="計算機実習2014" href="../index.html" />
    <link rel="next" title="実験レポートについて" href="../about.html" />
    <link rel="prev" title="問題12.2 - 2次元のランダムウォーク" href="../12-2_random_walk_d2/12-2.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="../about.html" title="実験レポートについて"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="../12-2_random_walk_d2/12-2.html" title="問題12.2 - 2次元のランダムウォーク"
             accesskey="P">前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="id1">
<h1><a class="toc-backref" href="#id10">問題12-4 - 継続型ランダムウォーク</a><a class="headerlink" href="#id1" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="contents topic" id="contents">
<p class="topic-title first">Contents</p>
<ul class="simple">
<li><a class="reference internal" href="#id1" id="id10">問題12-4 - 継続型ランダムウォーク</a><ul>
<li><a class="reference internal" href="#id2" id="id11">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3" id="id12">作成したプログラム</a><ul>
<li><a class="reference internal" href="#id4" id="id13">継続型ランダムウォークのシミュレーション-計算部</a></li>
<li><a class="reference internal" href="#id5" id="id14">継続型ランダムウォークのシミュレーション-実行部</a></li>
</ul>
</li>
<li><a class="reference internal" href="#id6" id="id15">実習課題</a></li>
<li><a class="reference internal" href="#id7" id="id16">まとめ</a></li>
<li><a class="reference internal" href="#huroku-12-4" id="id17">付録: ランダムウォークと拡散方程式</a></li>
<li><a class="reference internal" href="#id9" id="id18">参考文献</a></li>
</ul>
</li>
</ul>
</div>
<div class="section" id="id2">
<h2><a class="toc-backref" href="#id11">シミュレーションの目的</a><a class="headerlink" href="#id2" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>このシミュレーションでは、継続型ランダムウォーク、すなわち一つ前の遷移の履歴が遷移の方向を確率的に定めるような場合のランダムウォークを考える。このモデルの物理的な対応としては、後の問題で言及されているように、クロマトグラフィー柱の拡散の問題などが挙げられる。</p>
</div>
<div class="section" id="id3">
<h2><a class="toc-backref" href="#id12">作成したプログラム</a><a class="headerlink" href="#id3" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>本シミュレーションで作成したプログラムを以下に示す。</p>
<div class="section" id="id4">
<h3><a class="toc-backref" href="#id13">継続型ランダムウォークのシミュレーション-計算部</a><a class="headerlink" href="#id4" title="このヘッドラインへのパーマリンク">¶</a></h3>
<ul class="simple">
<li>HistoryDependentRW.py(<a class="reference download internal" href="../_downloads/HistoryDependentRW.py"><tt class="xref download docutils literal"><span class="pre">download</span></tt></a>)</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>  1
  2
  3
  4
  5
  6
  7
  8
  9
 10
 11
 12
 13
 14
 15
 16
 17
 18
 19
 20
 21
 22
 23
 24
 25
 26
 27
 28
 29
 30
 31
 32
 33
 34
 35
 36
 37
 38
 39
 40
 41
 42
 43
 44
 45
 46
 47
 48
 49
 50
 51
 52
 53
 54
 55
 56
 57
 58
 59
 60
 61
 62
 63
 64
 65
 66
 67
 68
 69
 70
 71
 72
 73
 74
 75
 76
 77
 78
 79
 80
 81
 82
 83
 84
 85
 86
 87
 88
 89
 90
 91
 92
 93
 94
 95
 96
 97
 98
 99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python</span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, June 2014.</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="kn">as</span> <span class="nn">plt</span>

<span class="k">class</span> <span class="nc">HistoryDependentRW</span><span class="p">():</span>
    
    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="mf">0.75</span><span class="p">,</span> <span class="n">l</span><span class="o">=</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">1</span><span class="p">),</span> <span class="n">nwalkers</span><span class="o">=</span><span class="mi">1000</span><span class="p">,</span> <span class="n">x0</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Initialize the values.</span>
<span class="sd">        </span>
<span class="sd">        alpha    : probability that a particle moves the same direction of the before one</span>
<span class="sd">        l        : step length</span>
<span class="sd">        nwalkers : number of trials</span>
<span class="sd">        x0       : initial position</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">alpha</span> <span class="o">=</span> <span class="n">alpha</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">l</span> <span class="o">=</span> <span class="n">l</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span> <span class="o">=</span> <span class="n">nwalkers</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x0</span> <span class="o">=</span> <span class="n">x0</span>
        
    <span class="k">def</span> <span class="nf">random_walk_d1</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">N</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Caluculate the displacements of each walkers.</span>
<span class="sd">        </span>
<span class="sd">        N : A list of walk steps</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">x</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">([</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="p">,</span> <span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)],</span> <span class="s">&#39;i&#39;</span><span class="p">)</span>
        <span class="n">x_direction</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">([</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="p">,</span> <span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)],</span> <span class="s">&#39;i&#39;</span><span class="p">)</span>
        <span class="n">p</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">random</span><span class="p">([</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="p">,</span> <span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span> <span class="c"># generate random number in [0,1)</span>
        <span class="n">alpha</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">alpha</span>
        <span class="n">l</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">l</span>
        <span class="n">x0</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x0</span>
                      
        <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">xrange</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="p">):</span>
            <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">x0</span>
            <span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="o">+</span><span class="mi">1</span> <span class="k">if</span> <span class="n">n</span> <span class="o">&lt;</span> <span class="nb">int</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="o">/</span><span class="mi">2</span><span class="p">)</span> <span class="k">else</span> <span class="o">-</span><span class="mi">1</span>
            <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">xrange</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)):</span>
                <span class="k">if</span> <span class="n">p</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">&lt;</span> <span class="n">alpha</span><span class="p">:</span>
                    <span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>                   
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="o">-</span><span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
                
                <span class="k">if</span> <span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                    <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span><span class="o">*</span><span class="n">l</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="n">x_direction</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span><span class="o">*</span><span class="n">l</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
                
        <span class="bp">self</span><span class="o">.</span><span class="n">x</span> <span class="o">=</span> <span class="n">x</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">N</span> <span class="o">=</span> <span class="n">N</span>
    
    <span class="k">def</span> <span class="nf">calc_ave</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Caluculate the average of displacements after max(N) steps.</span>
<span class="sd">        </span>
<span class="sd">        You can call the results by &quot;self.N&quot;, &quot;self.x_ave&quot;, and &quot;self.x_2_ave&quot;</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x_ave</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span><span class="o">/</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="o">*</span><span class="mf">1.</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">x_2_ave</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x</span><span class="o">**</span><span class="mi">2</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span><span class="o">/</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="o">*</span><span class="mf">1.</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">variance_x</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_2_ave</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">x_ave</span><span class="o">**</span><span class="mi">2</span>
      
    <span class="k">def</span> <span class="nf">show</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Show the graph.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="s">&#39;random walk&#39;</span><span class="p">,</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">8</span><span class="p">,</span><span class="mi">8</span><span class="p">))</span>
        
        <span class="n">x_ave</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x_ave</span><span class="p">[</span><span class="n">nvalue</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">nvalue</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">]</span>
        <span class="n">x_2_ave</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x_2_ave</span><span class="p">[</span><span class="n">nvalue</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">nvalue</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">]</span>
        <span class="n">variance_x</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">variance_x</span><span class="p">[</span><span class="n">nvalue</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">nvalue</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">]</span>
        
        <span class="n">ax1</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">311</span><span class="p">)</span>
        <span class="n">ax1</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">,</span> <span class="n">x_ave</span><span class="p">)</span>
        <span class="n">ax1</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s">r&#39;$&lt;x(N)&gt;$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>

        <span class="n">ax2</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">312</span><span class="p">)</span>
        <span class="n">ax2</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">,</span> <span class="n">x_2_ave</span><span class="p">)</span>
        <span class="n">ax2</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s">r&#39;$&lt;x^{2}(N)&gt;$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>

        <span class="n">ax3</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">313</span><span class="p">)</span>
        <span class="n">ax3</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s">r&#39;$&lt;\Delta x^{2}(N)&gt;$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
        <span class="n">ax3</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">,</span> <span class="n">variance_x</span><span class="p">)</span>
        <span class="n">ax3</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s">r&#39;$N$&#39;</span><span class="p">)</span>

        <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

    <span class="k">def</span> <span class="nf">caluculate_prob</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">_n</span><span class="p">):</span>
        <span class="n">N</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">N</span><span class="p">)</span>
        <span class="n">x</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">x</span>
        <span class="n">count_box</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">([</span><span class="n">N</span><span class="p">,</span> <span class="mi">2</span><span class="o">*</span><span class="n">N</span><span class="o">+</span><span class="mi">1</span><span class="p">],</span> <span class="s">&#39;f&#39;</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">xrange</span><span class="p">(</span><span class="n">N</span><span class="p">):</span>
            <span class="k">for</span> <span class="n">walker</span> <span class="ow">in</span> <span class="nb">xrange</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span><span class="p">):</span>
                <span class="n">count_box</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">N</span><span class="o">+</span><span class="n">x</span><span class="p">[</span><span class="n">walker</span><span class="p">][</span><span class="n">n</span><span class="p">]]</span> <span class="o">+=</span> <span class="mi">1</span>
        <span class="n">prob</span> <span class="o">=</span> <span class="n">count_box</span><span class="o">/</span><span class="bp">self</span><span class="o">.</span><span class="n">nwalkers</span>
        
        <span class="k">def</span> <span class="nf">show_for_n</span><span class="p">(</span><span class="n">_n</span><span class="p">):</span>
            
            <span class="n">xmin</span> <span class="o">=</span> <span class="o">-</span><span class="n">N</span>
            <span class="n">xmax</span> <span class="o">=</span> <span class="n">N</span>
            <span class="k">for</span> <span class="n">_x</span> <span class="ow">in</span> <span class="nb">xrange</span><span class="p">(</span><span class="mi">2</span><span class="o">*</span><span class="n">N</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
                <span class="k">if</span> <span class="n">prob</span><span class="p">[</span><span class="n">_n</span><span class="p">][</span><span class="n">_x</span><span class="p">]</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>
                    <span class="n">xmin</span><span class="p">,</span> <span class="n">xmax</span> <span class="o">=</span> <span class="n">_x</span><span class="o">-</span><span class="n">N</span><span class="p">,</span> <span class="n">N</span><span class="o">-</span><span class="n">_x</span>
                    <span class="k">break</span>
            
            <span class="n">xmargin</span> <span class="o">=</span> <span class="n">xmax</span><span class="o">*</span><span class="mf">0.1</span>
            <span class="n">ymax</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span><span class="n">prob</span><span class="p">[</span><span class="n">_n</span><span class="p">])</span>
            <span class="n">ymargin</span> <span class="o">=</span> <span class="n">ymax</span><span class="o">*</span><span class="mf">0.1</span>
                    
            <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="s">&#39;probability&#39;</span><span class="p">)</span>
            <span class="n">ax</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">111</span><span class="p">)</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">grid</span><span class="p">()</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="n">xmin</span><span class="o">-</span><span class="n">xmargin</span><span class="p">,</span><span class="n">xmax</span><span class="o">+</span><span class="n">xmargin</span><span class="p">)</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">ymax</span><span class="o">+</span><span class="n">ymargin</span><span class="p">)</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="nb">xrange</span><span class="p">(</span><span class="o">-</span><span class="n">N</span><span class="p">,</span> <span class="n">N</span><span class="o">+</span><span class="mi">1</span><span class="p">),</span> <span class="n">prob</span><span class="p">[</span><span class="n">_n</span><span class="p">])</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s">r&#39;$x$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s">r&#39;$P(x,N)$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
        
        <span class="n">show_for_n</span><span class="p">(</span><span class="n">_n</span><span class="p">)</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">rw</span> <span class="o">=</span> <span class="n">HistoryDependentRW</span><span class="p">()</span>
    <span class="n">N</span> <span class="o">=</span> <span class="nb">xrange</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">512</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">random_walk_d1</span><span class="p">(</span><span class="n">N</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">caluculate_prob</span><span class="p">(</span><span class="n">_n</span><span class="o">=</span><span class="mi">400</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">calc_ave</span><span class="p">()</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
    
</pre></div>
</td></tr></table></div>
</div>
<div class="section" id="id5">
<h3><a class="toc-backref" href="#id14">継続型ランダムウォークのシミュレーション-実行部</a><a class="headerlink" href="#id5" title="このヘッドラインへのパーマリンク">¶</a></h3>
<ul class="simple">
<li>12-4_history-dependent_rw.py(<a class="reference download internal" href="../_downloads/12-4_history-dependent_rw.py"><tt class="xref download docutils literal"><span class="pre">download</span></tt></a>)</li>
</ul>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python</span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, June 2014.</span>

<span class="kn">from</span> <span class="nn">HistoryDependentRW</span> <span class="kn">import</span> <span class="n">HistoryDependentRW</span>
    
<span class="k">def</span> <span class="nf">ex_a</span><span class="p">(</span><span class="n">alpha</span><span class="o">=</span><span class="mf">0.75</span><span class="p">,</span> <span class="n">caluculate_prob</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span> <span class="n">n</span><span class="o">=</span><span class="mi">400</span><span class="p">):</span>
    <span class="n">rw</span> <span class="o">=</span> <span class="n">HistoryDependentRW</span><span class="p">(</span><span class="n">alpha</span><span class="o">=</span><span class="n">alpha</span><span class="p">)</span>
    <span class="n">N</span> <span class="o">=</span> <span class="nb">xrange</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">512</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">random_walk_d1</span><span class="p">(</span><span class="n">N</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">caluculate_prob</span><span class="p">:</span>
        <span class="n">rw</span><span class="o">.</span><span class="n">caluculate_prob</span><span class="p">(</span><span class="n">_n</span><span class="o">=</span><span class="n">n</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">rw</span><span class="o">.</span><span class="n">calc_ave</span><span class="p">()</span>
        <span class="n">rw</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

<span class="k">def</span> <span class="nf">ex_b</span><span class="p">(</span><span class="n">alpha</span><span class="o">=</span><span class="mf">0.25</span><span class="p">,</span> <span class="n">target</span><span class="o">=</span><span class="s">&#39;nu&#39;</span><span class="p">,</span> <span class="n">N</span> <span class="o">=</span> <span class="nb">xrange</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">1001</span><span class="p">)):</span>
    
    <span class="k">if</span> <span class="ow">not</span> <span class="p">(</span><span class="n">target</span> <span class="o">==</span> <span class="s">&#39;nu&#39;</span> <span class="ow">or</span> <span class="s">&#39;D&#39;</span><span class="p">):</span>
        <span class="k">print</span> <span class="s">&quot;ArgumentError: target must be &#39;nu&#39; or &#39;D&#39;. &quot;</span>
        <span class="k">return</span> <span class="mi">0</span>
    
    <span class="k">else</span><span class="p">:</span>
        
        <span class="k">if</span> <span class="n">target</span> <span class="o">==</span> <span class="s">&#39;delta_x2&#39;</span><span class="p">:</span>
            <span class="n">N</span> <span class="o">=</span> <span class="p">[</span><span class="mi">8</span><span class="p">,</span><span class="mi">64</span><span class="p">,</span><span class="mi">256</span><span class="p">,</span><span class="mi">512</span><span class="p">]</span>
        
        <span class="n">rw</span> <span class="o">=</span> <span class="n">HistoryDependentRW</span><span class="p">(</span><span class="n">alpha</span><span class="o">=</span><span class="n">alpha</span><span class="p">)</span>
        <span class="n">rw</span><span class="o">.</span><span class="n">random_walk_d1</span><span class="p">(</span><span class="n">N</span><span class="p">)</span>
        <span class="n">rw</span><span class="o">.</span><span class="n">calc_ave</span><span class="p">()</span>
        
        <span class="k">if</span> <span class="n">target</span> <span class="o">==</span> <span class="s">&#39;delta_x2&#39;</span><span class="p">:</span>
             <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="n">N</span><span class="p">:</span>
                <span class="k">print</span> <span class="s">&#39;&lt;\Delta x^{2}(</span><span class="si">%d</span><span class="s">)&gt; = &#39;</span><span class="o">%</span><span class="n">n</span><span class="p">,</span> <span class="nb">str</span><span class="p">(</span><span class="n">rw</span><span class="o">.</span><span class="n">variance_x</span><span class="p">[</span><span class="n">n</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>
             <span class="k">return</span> <span class="mi">0</span>
        
        <span class="n">parameter0</span> <span class="o">=</span> <span class="p">[</span><span class="mf">1.0</span><span class="p">,</span> <span class="mf">1.0</span><span class="p">]</span> <span class="c"># initial values for optimize</span>

        <span class="k">def</span> <span class="nf">fit_func</span><span class="p">(</span><span class="n">parameter0</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">):</span>
            <span class="n">a</span> <span class="o">=</span> <span class="n">parameter0</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">b</span> <span class="o">=</span> <span class="n">parameter0</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">residual</span> <span class="o">=</span> <span class="n">y</span> <span class="o">-</span> <span class="p">(</span><span class="n">a</span><span class="o">*</span><span class="n">x</span><span class="o">+</span><span class="n">b</span><span class="p">)</span>
            <span class="k">return</span> <span class="n">residual</span>
        
        
        <span class="kn">import</span> <span class="nn">scipy.optimize</span> <span class="kn">as</span> <span class="nn">optimize</span>
        <span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
        
        <span class="k">if</span> <span class="n">target</span> <span class="o">==</span> <span class="s">&#39;nu&#39;</span><span class="p">:</span>
            <span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="kn">as</span> <span class="nn">plt</span>
            <span class="n">variance_x</span> <span class="o">=</span> <span class="p">[</span><span class="n">rw</span><span class="o">.</span><span class="n">variance_x</span><span class="p">[</span><span class="n">nvalue</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">nvalue</span> <span class="ow">in</span> <span class="n">N</span><span class="p">]</span>  
            <span class="n">ln_N</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="n">N</span><span class="p">)</span>
            <span class="n">ln_variance_x</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">log</span><span class="p">(</span><span class="n">variance_x</span><span class="p">)</span>
            
            <span class="n">result</span> <span class="o">=</span> <span class="n">optimize</span><span class="o">.</span><span class="n">leastsq</span><span class="p">(</span><span class="n">fit_func</span><span class="p">,</span> <span class="n">parameter0</span><span class="p">,</span> <span class="n">args</span><span class="o">=</span><span class="p">(</span><span class="n">ln_N</span><span class="p">,</span><span class="n">ln_variance_x</span><span class="p">))</span>
            
            <span class="k">print</span> <span class="s">&#39;nu =&#39;</span><span class="p">,</span> <span class="n">result</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span><span class="o">/</span><span class="mf">2.</span>

            <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$N$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$&lt;\Delta x^{2}(N)&gt;$&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">16</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">xscale</span><span class="p">(</span><span class="s">&#39;log&#39;</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">yscale</span><span class="p">(</span><span class="s">&#39;log&#39;</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">axis</span><span class="p">(</span><span class="s">&#39;equal&#39;</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">N</span><span class="p">,</span> <span class="n">variance_x</span><span class="p">)</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
        
        <span class="k">elif</span> <span class="n">target</span> <span class="o">==</span> <span class="s">&#39;D&#39;</span><span class="p">:</span>
            
            <span class="n">result</span> <span class="o">=</span> <span class="n">optimize</span><span class="o">.</span><span class="n">leastsq</span><span class="p">(</span><span class="n">fit_func</span><span class="p">,</span> <span class="n">parameter0</span><span class="p">,</span> 
                                      <span class="n">args</span><span class="o">=</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">arange</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)</span><span class="o">+</span><span class="mi">1</span><span class="p">),</span><span class="n">rw</span><span class="o">.</span><span class="n">x_2_ave</span><span class="p">)</span>
                                     <span class="p">)</span>
            <span class="k">print</span> <span class="s">&#39;D =&#39;</span><span class="p">,</span> <span class="n">result</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span><span class="o">/</span><span class="mf">4.</span>

<span class="k">def</span> <span class="nf">ex_c</span><span class="p">():</span>
    
    <span class="n">rw</span> <span class="o">=</span> <span class="n">HistoryDependentRW</span><span class="p">(</span><span class="n">alpha</span><span class="o">=</span><span class="mf">0.75</span><span class="p">,</span> <span class="n">l</span><span class="o">=</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">0</span><span class="p">),</span> <span class="n">nwalkers</span><span class="o">=</span><span class="mi">1000</span><span class="p">)</span>
    <span class="n">N</span> <span class="o">=</span> <span class="nb">xrange</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">512</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">random_walk_d1</span><span class="p">(</span><span class="n">N</span><span class="p">)</span>
    <span class="n">rw</span><span class="o">.</span><span class="n">caluculate_prob</span><span class="p">(</span><span class="n">_n</span><span class="o">=</span><span class="mi">300</span><span class="p">)</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    
<span class="c">#    ex_a(alpha=0.75, caluculate_prob=False, n=400)</span>
    
<span class="c">#    ex_b(alpha=0.75,target=&#39;D&#39;, N = xrange(1,1001))</span>
    <span class="c"># taget must be &#39;delta_x2&#39; or &#39;nu&#39; or &#39;D&#39;</span>
    
    <span class="n">ex_c</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
</div>
</div>
<div class="section" id="id6">
<h2><a class="toc-backref" href="#id15">実習課題</a><a class="headerlink" href="#id6" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ol class="loweralpha simple">
<li>&#8220;継続型&#8221;ランダムウォークでは、遷移、すなわち&#8221;ジャンプ&#8221;の確率が直前の履歴に依存する。1次元格子上のランダムウォークを考え、すでにN-1ステップ進んでいるとする。Nステップ目は確率<img class="math" src="../_images/math/ad59b6e24a4a00ac621801f8d7513d68be654ab5.png" alt="\alpha"/>で同じ方向に進み、確率<img class="math" src="../_images/math/de6153ef1dccee84904f1dbac1e439589f70d375.png" alt="1-\alpha"/>で反対方向に進む。この1次元の継続型ランダムウォークのモンテカルロ・シミュレーションを行うプログラムを書け。そして、<img class="math" src="../_images/math/cd355b441461cec3260e9ceb3c3c59ce4fde62ff.png" alt="&lt;x(N)&gt;,&lt;x^{2}(N)&gt;,&lt;\Delta x^{2}(N)&gt;,P(x,N)"/>を計算せよ。粒子の初期位置と初期の方向を設定する必要がある。この継続型ランダムウォークで<img class="math" src="../_images/math/41e87dc743b9de9dda37661008af592d67bc9773.png" alt="\alpha = 1/2"/>の極限はどうなるか。</li>
</ol>
<p>上で示したプログラムを用いて、継続型の1次元ランダムウォークのシミュレーションを行った。<a class="reference internal" href="#fig-12-4-f1"><em>図1</em></a>に、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>に対する<img class="math" src="../_images/math/80322654ba338c5af7d0ab4567a18a267e3a453a.png" alt="&lt;x(N)&gt;"/>と<img class="math" src="../_images/math/a0c186cb31dc1b737de27b78adc6702f1372d3cd.png" alt="&lt;x^{2}(N)&gt;"/>、<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>のグラフを示した。このグラフから、<img class="math" src="../_images/math/80322654ba338c5af7d0ab4567a18a267e3a453a.png" alt="&lt;x(N)&gt;"/>は、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>に依存せず、零となることが分かる。また、<img class="math" src="../_images/math/a0c186cb31dc1b737de27b78adc6702f1372d3cd.png" alt="&lt;x^{2}(N)&gt;"/>と<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>は<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>に比例していることが分かる。</p>
<div class="align-center figure" id="fig-12-4-f1">
<a class="reference internal image-reference" href="../_images/figure_19.png"><img alt="figure_1.png" src="../_images/figure_19.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/2a9fbbb5d0f0aaff36608f745ad0216ba9ab7423.png" alt="\alpha=0.75"/>のとき、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>に対する<img class="math" src="../_images/math/80322654ba338c5af7d0ab4567a18a267e3a453a.png" alt="&lt;x(N)&gt;"/>と<img class="math" src="../_images/math/a0c186cb31dc1b737de27b78adc6702f1372d3cd.png" alt="&lt;x^{2}(N)&gt;"/>、<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>のグラフ</p>
</div>
<p>次に、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>ステップの移動の後に粒子が位置<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>に見出される確率<img class="math" src="../_images/math/6ea434b0e3279bdff3274bc657833ccc03e2bb1a.png" alt="P(x,N)"/>の計算を行い、<img class="math" src="../_images/math/84c294650aa190182010911c0f2846ca6bd0b5fd.png" alt="N=400"/>とした時の<img class="math" src="../_images/math/826252e043e9c5da02ac4d69703fc733e7325418.png" alt="P(x,400)"/>のグラフを、横軸を<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>、縦軸を確率<img class="math" src="../_images/math/f48b617185733d8dd6712643f1ab17c736661a06.png" alt="P"/>としてプロットしたものを<a class="reference internal" href="#fig-12-4-f2"><em>図2</em></a>に示した。このグラフから、確率分布はガウス分布の定数倍の連続関数に従うと予想され(問題7.6による)、先ほどの<a class="reference internal" href="#fig-12-4-f1"><em>図1</em></a>の結果からも、Nが大きくなるほど、確率分布の裾の拡がりは<img class="math" src="../_images/math/3e28a65f556fb49f2c54a228b1661091cb177954.png" alt="\sqrt N"/>で大きくなることが分かる。このとき<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>が奇数の時の確率はいつも零であるが、これは<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>が偶数であることに起因するものであって、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>を奇数に取ると、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>ステップ後に偶数の<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>に到達する確率は零となる。また、この効果によって、確率分布がガウス分布を2倍の高さにしたものになっている、とも説明できる。</p>
<div class="align-center figure" id="fig-12-4-f2">
<a class="reference internal image-reference" href="../_images/figure_25.png"><img alt="figure_2.png" src="../_images/figure_25.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/84c294650aa190182010911c0f2846ca6bd0b5fd.png" alt="N=400"/>のとき、<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>に対する<img class="math" src="../_images/math/6ea434b0e3279bdff3274bc657833ccc03e2bb1a.png" alt="P(x,N)"/>のグラフ</p>
</div>
<p>また、この継続型ランダムウォークの<img class="math" src="../_images/math/bc222ef14ae09d78f84bc17c983b66e531f31dc1.png" alt="\alpha=0.5"/>の極限を考えたとすると、これは<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>ステップ目の遷移の確率が<img class="math" src="../_images/math/19f9ae9a7d789d9a8e661b478df966192038b540.png" alt="N-1"/>ステップ目の確率に依存しないことを意味するので、単純な1次元ランダムウォークで<img class="math" src="../_images/math/cb3c0f2c4c79d48324ced8cecfc59b16dbaa86a0.png" alt="p=q=0.5"/>とした時と等価になるはずである。実際に、作成したプログラムで<img class="math" src="../_images/math/bc222ef14ae09d78f84bc17c983b66e531f31dc1.png" alt="\alpha=0.5"/>とした時の<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>に対する<img class="math" src="../_images/math/80322654ba338c5af7d0ab4567a18a267e3a453a.png" alt="&lt;x(N)&gt;"/>と<img class="math" src="../_images/math/a0c186cb31dc1b737de27b78adc6702f1372d3cd.png" alt="&lt;x^{2}(N)&gt;"/>、<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>のグラフを作成し、これを<a class="reference internal" href="#fig-12-4-f3"><em>図3</em></a>に示したが、確かに単純なランダムウォークの分散について得られた関係</p>
<div class="math">
<p><img src="../_images/math/610e8a4dde5e763deb314a1d3ebb1129c9504a40.png" alt="&lt;\Delta x^{2}(N)&gt; = l^{2}N"/></p>
</div><p>を満たしていることが分かる。</p>
<div class="align-center figure" id="fig-12-4-f3">
<a class="reference internal image-reference" href="../_images/figure_35.png"><img alt="figure_3.png" src="../_images/figure_35.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/bc222ef14ae09d78f84bc17c983b66e531f31dc1.png" alt="\alpha=0.5"/>のとき、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>に対する<img class="math" src="../_images/math/80322654ba338c5af7d0ab4567a18a267e3a453a.png" alt="&lt;x(N)&gt;"/>と<img class="math" src="../_images/math/a0c186cb31dc1b737de27b78adc6702f1372d3cd.png" alt="&lt;x^{2}(N)&gt;"/>、<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>のグラフ</p>
</div>
<ol class="loweralpha simple" start="2">
<li><img class="math" src="../_images/math/0af71c020b91adf82a3ba589d5bcfb369ece9984.png" alt="\alpha =0.25"/>と<img class="math" src="../_images/math/be4a7a6c1d8e700b424878c5067bad5deae65e8a.png" alt="\alpha = 0.75"/>の場合を考えて、<img class="math" src="../_images/math/298c37a491d3cda8013add3606e9d648cc1af554.png" alt="N=8,64,256,512"/>について、<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>を求めよ。さらに大きい<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>についての<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/> の<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>に対する両対数プロットから<img class="math" src="../_images/math/d67fb61cfffca2cc069e083d76cb6220b4ca14c8.png" alt="\nu"/>の値を求めよ。<img class="math" src="../_images/math/d67fb61cfffca2cc069e083d76cb6220b4ca14c8.png" alt="\nu"/>は<img class="math" src="../_images/math/ad59b6e24a4a00ac621801f8d7513d68be654ab5.png" alt="\alpha"/>に依存するか。<img class="math" src="../_images/math/7f9431d7b42ee8c3c0dbe1ed2d40d3e198c708af.png" alt="\nu \simeq 1/2"/>なら、<img class="math" src="../_images/math/0af71c020b91adf82a3ba589d5bcfb369ece9984.png" alt="\alpha =0.25"/>と<img class="math" src="../_images/math/861fff1b38bab768baf0a01f3c57f6e210a8ce9e.png" alt="0.75"/>について自己拡散係数Dを求めよ。<img class="math" src="../_images/math/cde0a97fcd597deb56b68ced9d4f4c4af9da098d.png" alt="D(\alpha \neq 0.5)"/>が<img class="math" src="../_images/math/2be043adccd07ccacab04d620d281198906f5dee.png" alt="D(\alpha = 0.5)"/>より大きくなる(または小さくなる)物理的理由を述べよ。</li>
</ol>
<p><img class="math" src="../_images/math/5c3ed7be0db5c73a7c841ebe8b301a47c526b1f2.png" alt="\alpha=0.25"/> と<img class="math" src="../_images/math/be4a7a6c1d8e700b424878c5067bad5deae65e8a.png" alt="\alpha = 0.75"/>  のそれぞれの場合について、<img class="math" src="../_images/math/298c37a491d3cda8013add3606e9d648cc1af554.png" alt="N=8,64,256,512"/>に関して<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>を計算し、<a class="reference internal" href="#tab-12-4-t1"><em>表1</em></a>、<a class="reference internal" href="#tab-12-4-t1"><em>表2</em></a>にまとめた。</p>
<span class="target" id="tab-12-4-t1"></span><span class="target" id="tab-12-4-t2"></span><p>そして、さらに大きい<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>(<img class="math" src="../_images/math/63fece345621a3e2c3658f7e57f20e04a3bd3c16.png" alt="100 \le N \le 10000"/>)について、<img class="math" src="../_images/math/0af71c020b91adf82a3ba589d5bcfb369ece9984.png" alt="\alpha =0.25"/>のとき<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/> の<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>に対する両対数プロットを<a class="reference internal" href="#fig-12-4-f4"><em>図4</em></a>に示した。また、このときの傾きの大きさの1/2が<img class="math" src="../_images/math/d67fb61cfffca2cc069e083d76cb6220b4ca14c8.png" alt="\nu"/>であったから、グラフの直線の傾きから<img class="math" src="../_images/math/d67fb61cfffca2cc069e083d76cb6220b4ca14c8.png" alt="\nu"/>の値を求め、その値は<img class="math" src="../_images/math/943b4403ecfe14f0d4bbfc187066835b775281c3.png" alt="\nu = 0.504529949219"/>であった。また、<img class="math" src="../_images/math/2a9fbbb5d0f0aaff36608f745ad0216ba9ab7423.png" alt="\alpha=0.75"/>の場合も計算を行ったが、このときの値は<img class="math" src="../_images/math/f3d8e19b2b1494e415fe59ffee6eba378abe73db.png" alt="\nu=0.503435215609"/>であり、他のいくつかの試行からも<img class="math" src="../_images/math/d67fb61cfffca2cc069e083d76cb6220b4ca14c8.png" alt="\nu"/>は<img class="math" src="../_images/math/ad59b6e24a4a00ac621801f8d7513d68be654ab5.png" alt="\alpha"/>に依存しないことが分かる。</p>
<div class="align-center figure" id="fig-12-4-f4">
<a class="reference internal image-reference" href="../_images/figure_43.png"><img alt="../_images/figure_43.png" src="../_images/figure_43.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/> の<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>に対する両対数プロット(<img class="math" src="../_images/math/0af71c020b91adf82a3ba589d5bcfb369ece9984.png" alt="\alpha =0.25"/>)</p>
</div>
<p>次に、<img class="math" src="../_images/math/0af71c020b91adf82a3ba589d5bcfb369ece9984.png" alt="\alpha =0.25"/>と<img class="math" src="../_images/math/2a9fbbb5d0f0aaff36608f745ad0216ba9ab7423.png" alt="\alpha=0.75"/>について自己拡散係数Dを求めることにする。<a class="reference internal" href="#huroku-12-4"><em>付録</em></a>に示したように、<img class="math" src="../_images/math/425d86ba2f2979d75b7535c2bcf92c33ed6b285a.png" alt="d"/>次元空間では</p>
<div class="math">
<p><img src="../_images/math/a5fd9e7652da2057a571813aa35b129b42335782.png" alt="&lt;x^{2}(t)&gt; = 2dDt"/></p>
</div><p>であり、また<img class="math" src="../_images/math/ef9270877405055756d345facd044e4ab297f858.png" alt="t"/>は<img class="math" src="../_images/math/5b4271afe7fc7c0ee84172e0ad19b82caf450c00.png" alt="\Delta t"/>を時間の刻み幅として<img class="math" src="../_images/math/a939ac1c24d9ce78b7b3a3cb8270b6b79a400d97.png" alt="t=N \Delta t"/>と書けるから、今の場合<img class="math" src="../_images/math/5b6395936ebbfe90cbe37ea0b0cf890c252c9e76.png" alt="d = 2"/>であり、<img class="math" src="../_images/math/0493090a3e751ef33ee78b784973cf96648cc9d2.png" alt="\Delta t=1"/>として</p>
<div class="math">
<p><img src="../_images/math/53d9d4cb19751c9c970aae50c8f54efac0e0bf38.png" alt="&lt;x^{2}(t)&gt; = 4DN"/></p>
</div><p>となる。</p>
<p>この式から拡散係数<img class="math" src="../_images/math/9dfa31437b58c0473299320aa638151cd88cf61b.png" alt="D"/>を求めると、<img class="math" src="../_images/math/0af71c020b91adf82a3ba589d5bcfb369ece9984.png" alt="\alpha =0.25"/>のとき<img class="math" src="../_images/math/677b380ba088aecc877d3247c3e1c3aa88d4b661.png" alt="D=0.0800663199903"/>、<img class="math" src="../_images/math/3f800e001eb98fd21105a60cca57c5ef42989d2b.png" alt="\alpha =0.75"/>のとき<img class="math" src="../_images/math/4bc1364ec2e56e80c50a28eeaa79683ed4253399.png" alt="D =  0.787805747407"/>となった。また、<img class="math" src="../_images/math/bc222ef14ae09d78f84bc17c983b66e531f31dc1.png" alt="\alpha=0.5"/>のときは<img class="math" src="../_images/math/b700f39a825ab028faf365832bb68d81aeb2d0f8.png" alt="D=0.258759185637"/>であった。<img class="math" src="../_images/math/61f04da3f18abf96b0c9ad2239e68f8ed0ae864c.png" alt="D(\alpha = 0.75)"/>は<img class="math" src="../_images/math/2be043adccd07ccacab04d620d281198906f5dee.png" alt="D(\alpha = 0.5)"/>より大きく、<img class="math" src="../_images/math/e6d77b19035fea1f20d0135c764afb162ca92bbe.png" alt="D(\alpha = 0.25)"/>は<img class="math" src="../_images/math/2be043adccd07ccacab04d620d281198906f5dee.png" alt="D(\alpha = 0.5)"/>より小さくなっており、これは<img class="math" src="../_images/math/ad59b6e24a4a00ac621801f8d7513d68be654ab5.png" alt="\alpha"/>の定義を思い出せば理解できることである。<img class="math" src="../_images/math/ad59b6e24a4a00ac621801f8d7513d68be654ab5.png" alt="\alpha"/>は1回前の進行方向と同じ方向に進む確率であるから、この値が小さいということは、1回前の進行方向とは逆の方向に進む確率が高いということを意味し、原点の付近で周期2ステップで振動するような場合に近くなることが分かる。逆に<img class="math" src="../_images/math/ad59b6e24a4a00ac621801f8d7513d68be654ab5.png" alt="\alpha"/>の値が大きいときには、初期値によって定められた方向に進みやすく、その後折り返した後も継続的に長い距離同じ方向に進むことになる。結果として粒子の移動した距離の分散は大きくなることが分かる。</p>
<ol class="loweralpha simple" start="3">
<li>継続型ランダムウォークは、状態が直前の遷移によって定義される多重状態のランダムウォークの一例とみなすことができる。上の例では、粒子は2つの状態のうちのどちらか一方にいて、各ステップについて同じ状態にとどまる確率と遷移する確率は、それぞれ<img class="math" src="../_images/math/ad59b6e24a4a00ac621801f8d7513d68be654ab5.png" alt="\alpha"/>と<img class="math" src="../_images/math/de6153ef1dccee84904f1dbac1e439589f70d375.png" alt="1-\alpha"/>である。この2状態ランダムウォークの最も初期の適用例の1つにクロマトグラフィー柱の拡散の問題がある。クロマトグラフィー柱の中の分子は運動状態(一定速度<img class="math" src="../_images/math/0e22076955898e6c9bb38aa079135195c24dc81e.png" alt="v"/>)か、捕らえられた状態(速度0)のどちらかにあるとする。この場合、各ステップで位置を<img class="math" src="../_images/math/5afef8883a1e1142173e76df8d16e764b2779782.png" alt="\pm 1"/>変化させる代わりに、各ステップで位置を<img class="math" src="../_images/math/2902a4739e09709096f06c669828f491ed0007b1.png" alt="+v"/>か0だけ変化させる。実験的に興味のある量は、分子がNステップの後に距離xだけ移動する確率<img class="math" src="../_images/math/6ea434b0e3279bdff3274bc657833ccc03e2bb1a.png" alt="P(x,N)"/>である。<img class="math" src="../_images/math/6b93964bcde101c3d8f4a4a080b5fc6902861690.png" alt="v = 1, \alpha = 0.75"/>として、<img class="math" src="../_images/math/6ea434b0e3279bdff3274bc657833ccc03e2bb1a.png" alt="P(x,N)"/>の定性的な振る舞いを調べよ。分子はどちらの状態にも拡散することができないのに、分子の有効拡散係数は定義できる理由を説明せよ。</li>
</ol>
<p>先程まで考えていた問題は、2状態ランダムウォークの例とみなすことができて、その2つの状態とは右に1だけ進む状態と左に1だけ進む状態である。また、各ステップについて同じ状態にとどまる確率と遷移する確率は、それぞれ<img class="math" src="../_images/math/ad59b6e24a4a00ac621801f8d7513d68be654ab5.png" alt="\alpha"/>と<img class="math" src="../_images/math/de6153ef1dccee84904f1dbac1e439589f70d375.png" alt="1-\alpha"/>である。2状態ランダムウォークの最も初期の適用例の1つにクロマトグラフィー柱の拡散の問題があり、クロマトグラフィー柱の中の分子は運動状態(一定速度<img class="math" src="../_images/math/0e22076955898e6c9bb38aa079135195c24dc81e.png" alt="v"/>)か、捕らえられた状態(速度0)のどちらかにあるとする。この場合、各ステップで位置を<img class="math" src="../_images/math/2902a4739e09709096f06c669828f491ed0007b1.png" alt="+v"/>か<img class="math" src="../_images/math/74c081db590f3d35421c1f6b9afd4cdda36ee210.png" alt="0"/>だけ変化させる。以上のようなプログラムを<img class="math" src="../_images/math/d7c6ee2a80ffa8a56c52fbcd65df2df163e5c759.png" alt="v = 1"/>, <img class="math" src="../_images/math/be4a7a6c1d8e700b424878c5067bad5deae65e8a.png" alt="\alpha = 0.75"/>として実行し、その結果得られた<img class="math" src="../_images/math/6ea434b0e3279bdff3274bc657833ccc03e2bb1a.png" alt="P(x,N)"/>のグラフを<a class="reference internal" href="#fig-12-4-f5"><em>図5</em></a>に示した(<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>軸の方向が逆転していることに注意)。このグラフや、他のNについて行ったシミュレーションによって、Nステップ後に粒子のいる位置<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>の期待値は<img class="math" src="../_images/math/0feb52801a927a6eacffc3ee7bedea944bd8959b.png" alt="N/2"/>であり、また確率分布はガウス分布に近い形となっていることが分かる。問題aで得られた確率<img class="math" src="../_images/math/6ea434b0e3279bdff3274bc657833ccc03e2bb1a.png" alt="P(x,N)"/>との違いは、期待値が0でない値をもつことと、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>の偶奇による確率0の位置が存在しないことである。また、この条件で分子はどちらの状態にも拡散することはできないが、問題bで考察したように、拡散係数<img class="math" src="../_images/math/9dfa31437b58c0473299320aa638151cd88cf61b.png" alt="D"/>は<img class="math" src="../_images/math/a0c186cb31dc1b737de27b78adc6702f1372d3cd.png" alt="&lt;x^{2}(N)&gt;"/>と関連付けられ、この意味において有効拡散係数を定義することができる。</p>
<div class="align-center figure" id="fig-12-4-f5">
<a class="reference internal image-reference" href="../_images/figure_62.png"><img alt="../_images/figure_62.png" src="../_images/figure_62.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/84c294650aa190182010911c0f2846ca6bd0b5fd.png" alt="N=400"/>のとき、<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>に対する<img class="math" src="../_images/math/6ea434b0e3279bdff3274bc657833ccc03e2bb1a.png" alt="P(x,N)"/>のグラフ</p>
</div>
</div>
<div class="section" id="id7">
<h2><a class="toc-backref" href="#id16">まとめ</a><a class="headerlink" href="#id7" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>継続型ランダムウォークと、それに関連して、2状態ランダムウォークについて理解することができた。</p>
</div>
<div class="section" id="huroku-12-4">
<span id="id8"></span><h2><a class="toc-backref" href="#id17">付録: ランダムウォークと拡散方程式</a><a class="headerlink" href="#huroku-12-4" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>ランダムウォークと拡散方程式の関係を理解するために、拡散方程式から<img class="math" src="../_images/math/e8b4acec9cbfb51ca2c0d5a3f15fe233398c65a9.png" alt="&lt;x(t)&gt;"/>が<img class="math" src="../_images/math/74c081db590f3d35421c1f6b9afd4cdda36ee210.png" alt="0"/>になることと<img class="math" src="../_images/math/131d0622b78258c0082d197772f9c9bd58b88d1b.png" alt="&lt;x^{2}(t)&gt;"/>が<img class="math" src="../_images/math/ef9270877405055756d345facd044e4ab297f858.png" alt="t"/>に比例することが導かれることを示そう。拡散方程式は</p>
<div class="math" id="equation-12-4-e1">
<p><span class="eqno">(1)</span><img src="../_images/math/b08b884ed2ede4b1e0cefce7bd00f798532e36d5.png" alt="\frac{\partial P(x,t)}{\partial t} = D \frac{\partial^{2} P(x,t)}{\partial x^{2}}"/></p>
</div><p>である。<img class="math" src="../_images/math/e8b4acec9cbfb51ca2c0d5a3f15fe233398c65a9.png" alt="&lt;x(t)&gt;"/>と<img class="math" src="../_images/math/131d0622b78258c0082d197772f9c9bd58b88d1b.png" alt="&lt;x^{2}(t)&gt;"/>の<img class="math" src="../_images/math/ef9270877405055756d345facd044e4ab297f858.png" alt="t"/>依存性を式<a href="#equation-12-4-e1">(1)</a>から導くために、任意の<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>の関数の平均を</p>
<div class="math">
<p><img src="../_images/math/e4ff27c4e5387af908deecea140edd018cc3742b.png" alt="&lt;f(x,t)&gt; = \int_{-\infty}^{\infty} f(x)P(x,t)dx"/></p>
</div><p>で表す。そうすると変位の平均は</p>
<div class="math" id="equation-12-4-e2">
<p><span class="eqno">(2)</span><img src="../_images/math/73cbbe4827982278aeedf2bb88c75ea8229c4093.png" alt="&lt;x(t)&gt; = \int_{-\infty}^{\infty} xP(x,t)dx"/></p>
</div><p>で与えられる。式<a href="#equation-12-4-e2">(2)</a>の右辺の積分を実行するために、式<a href="#equation-12-4-e1">(1)</a>の両辺に<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>を掛けて形式的に<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>について積分する。</p>
<div class="math" id="equation-12-4-e3">
<p><span class="eqno">(3)</span><img src="../_images/math/d55127f515bbeda8036763abea40d9236967aefa.png" alt="\int_{-\infty}^{\infty} x \frac{\partial P(x,t)}{\partial t}dx = D \int_{-\infty}^{\infty} x \frac{\partial^{2} P(x,t)}{\partial x^{2}}dx"/></p>
</div><p>左辺は</p>
<div class="math">
<p><img src="../_images/math/2bafd6e5da4c3420eadb0a5c3dc38b4a148d6934.png" alt="\int_{-\infty}^{\infty} x \frac{\partial P(x,t)}{\partial t}dx = \frac{\partial}{\partial t} \int_{-\infty}^{\infty} x P(x,t)dx = \frac{\partial}{\partial t} &lt;x&gt;"/></p>
</div><p>と表される。式<a href="#equation-12-4-e3">(3)</a>の右辺は部分積分をすると、求めている形に書き換えられる。</p>
<div class="math" id="equation-12-4-e4">
<p><span class="eqno">(4)</span><img src="../_images/math/a3903ed8998561fea55c4921f45bd0cb85545bbe.png" alt="D \int_{-\infty}^{\infty} x \frac{\partial^{2} P(x,t)}{\partial x^{2}}dx = D x \frac{\partial P(x,t)}{\partial x}\biggm|_{x = -\infty}^{x = \infty} - D \int_{-\infty}^{\infty} x \frac{\partial P(x,t)}{\partial x}dx"/></p>
</div><p><img class="math" src="../_images/math/bf060a79c23e355dc6540602c829e562a321118e.png" alt="P(x=\pm \infty, t) = 0"/>であり、<img class="math" src="../_images/math/6c210deb83388d4803c140cc88403cf07de1c37f.png" alt="x=\pm 1"/>では<img class="math" src="../_images/math/f48b617185733d8dd6712643f1ab17c736661a06.png" alt="P"/>のすべての空間微分は<img class="math" src="../_images/math/74c081db590f3d35421c1f6b9afd4cdda36ee210.png" alt="0"/>なので、式<a href="#equation-12-4-e4">(4)</a>の右辺第1項は0になる。第2項は、積分すると<img class="math" src="../_images/math/57a1660e458bd52052411c20cb08a891bd0fcb1a.png" alt="D[P(x = \infty, t)-P(x = \infty, t)]"/>となるので、やはり0になる。したがって</p>
<div class="math">
<p><img src="../_images/math/3a9e381b7f1cfbb416e692c8c9424df347a0f321.png" alt="\frac{\partial}{\partial x}&lt;x&gt; = 0"/></p>
</div><p>が得られ、<img class="math" src="../_images/math/bab3d445204c4c41f8ea60354ada2878eed2d173.png" alt="&lt;x&gt;"/>は時間によらない定数になる。<img class="math" src="../_images/math/4e2677b4edfbb85a135b7807d780a44ffa83f052.png" alt="t=0"/>で<img class="math" src="../_images/math/55ba271999995cac02cf578362df5be030594ed6.png" alt="x=0"/>なので、結局、すべての<img class="math" src="../_images/math/ef9270877405055756d345facd044e4ab297f858.png" alt="t"/>について<img class="math" src="../_images/math/1277017943e29284d26ceda13ca352d969e99346.png" alt="&lt;x&gt;=0"/>が成り立つという結論になる。<img class="math" src="../_images/math/131d0622b78258c0082d197772f9c9bd58b88d1b.png" alt="&lt;x^{2}(t)&gt;"/>を計算するには2度の部分積分が必要であり、そうすると</p>
<div class="math">
<p><img src="../_images/math/7731ff2102f0215ef7da0e593f317fc9c515d92f.png" alt="\frac{\partial}{\partial x}&lt;x^{2}(t)&gt; = 2D"/></p>
</div><p>したがって</p>
<div class="math">
<p><img src="../_images/math/3ec376bdc6435c4cae3268b6361ef9408a7f3441.png" alt="&lt;x^{2}(t)&gt; = 2Dt"/></p>
</div><p>が得られる。こうして、ランダムウォークと拡散方程式が同じ時間依存性を持つことがわかる。<img class="math" src="../_images/math/425d86ba2f2979d75b7535c2bcf92c33ed6b285a.png" alt="d"/>次元空間では、<img class="math" src="../_images/math/4106b56306f84c6235988b76d741e092dd264a92.png" alt="2D"/>は<img class="math" src="../_images/math/f674855e8f6091e3bbc530bf23aeaa1aa2893317.png" alt="2dD"/>に置き換えられる。</p>
</div>
<div class="section" id="id9">
<h2><a class="toc-backref" href="#id18">参考文献</a><a class="headerlink" href="#id9" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li>ハーベイ・ゴールド,ジャン・トボチニク,石川正勝・宮島佐介訳『計算物理学入門』,ピアソン・エデュケーション, 2000.</li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">問題12-4 - 継続型ランダムウォーク</a><ul>
<li><a class="reference internal" href="#id2">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3">作成したプログラム</a><ul>
<li><a class="reference internal" href="#id4">継続型ランダムウォークのシミュレーション-計算部</a></li>
<li><a class="reference internal" href="#id5">継続型ランダムウォークのシミュレーション-実行部</a></li>
</ul>
</li>
<li><a class="reference internal" href="#id6">実習課題</a></li>
<li><a class="reference internal" href="#id7">まとめ</a></li>
<li><a class="reference internal" href="#huroku-12-4">付録: ランダムウォークと拡散方程式</a></li>
<li><a class="reference internal" href="#id9">参考文献</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="../12-2_random_walk_d2/12-2.html"
                        title="前の章へ">問題12.2 - 2次元のランダムウォーク</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="../about.html"
                        title="次の章へ">実験レポートについて</a></p>
  <h3>このページ</h3>
  <ul class="this-page-menu">
    <li><a href="../_sources/12-4_history-dependent_rw/12-4.txt"
           rel="nofollow">ソースコードを表示</a></li>
  </ul>
<div id="searchbox" style="display: none">
  <h3>クイック検索</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="検索" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    モジュール、クラス、または関数名を入力してください
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="../about.html" title="実験レポートについて"
             >次へ</a> |</li>
        <li class="right" >
          <a href="../12-2_random_walk_d2/12-2.html" title="問題12.2 - 2次元のランダムウォーク"
             >前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2014, Shotaro Fujimoto.
      このドキュメントは <a href="http://sphinx-doc.org/">Sphinx</a> 1.2.2 で生成しました。
    </div>
  </body>
</html>